
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.EmpresaComprovantePassagemConfigDAO;
import com.rjconsultores.ventaboletos.entidad.EmpresaComprovantePassagemConfig;

@Repository("empresaComprovantePassagemConfigDAO")
public class EmpresaComprovantePassagemConfigHibernateDAO extends
		GenericHibernateDAO<EmpresaComprovantePassagemConfig, Integer> implements EmpresaComprovantePassagemConfigDAO {

	@Autowired
	public EmpresaComprovantePassagemConfigHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<EmpresaComprovantePassagemConfig> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	public EmpresaComprovantePassagemConfig buscarChave(String chave, Integer empresaId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		c.add(Restrictions.eq("chave", chave));
		c.add(Restrictions.eq("empresa.empresaId", empresaId));

		return (EmpresaComprovantePassagemConfig) c.uniqueResult();
	}

	public List<EmpresaComprovantePassagemConfig> buscarByEmpresa(Integer empresaId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa.empresaId", empresaId));

		return c.list();
	}
}
